//+------------------------------------------------------------------+
//|                                        AlMotawkel_EA With TS.mq4 |
//|                                 Copyright  2006, Shalby Slophan |
//|                                   http://www.arabictrader.com/vb |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Shalby Slophan"
#property link      "http://www.arabictrader.com/vb"

bool OrderExecuted = false, ObserverActivated = false, Closed = false;
int MagicNo = 3182006, Type = -1;
int DiffBar = -1, Ticket = 0;
double Price2Buy = 0, Price2Sell = 0;
double lcp = 0, CrossPoint = 0;
//---- input parameters
extern int FasterMAPeriod = 5;
extern int FasterShift    = 0;
extern int FasterMethod   = 2;
extern int FasterApplyTo  = 0;

extern int SlowerMAPeriod = 8;
extern int SlowerShift    = 0;
extern int SlowerMethod   = 2;
extern int SlowerApplyTo  = 1;

extern int TimeFrame      = 0;
extern int Lots           = 1;
extern int StopLoss       = 0.0;
extern int TakeProfit     = 0.0;
extern double TrailingStop = 0;
extern int PipsFilter     = 20;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   DiffBar = Bars;
   OrderExecuted = true;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //////////////////////////////////////////////////////////////////////////////////
   // Trailing Stop /////////////////////////////////////////////////////////////////
   //////////////////////////////////////////////////////////////////////////////////
   if(TrailingStop > 0)   
   {
      for (int x = 0; x < OrdersTotal(); x++)
      {
         if( OrderSelect(x, SELECT_BY_POS, MODE_TRADES) )
         {
            if ( Symbol() == OrderSymbol() && MagicNo == OrderMagicNumber() )
            {
               if (OrderType() == OP_BUY)
               {
                  double ProfitB = Bid - OrderOpenPrice();
                  if(ProfitB >= (Point * TrailingStop)) 
                  {
                     double DiffST = Bid - OrderStopLoss();
                     if (DiffST > TrailingStop * Point)
                        OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, Green); 
                  }
               } 
               if (OrderType() == OP_SELL)
               {
                  double ProfitS = OrderOpenPrice() - Ask;
                  if(ProfitS >= (Point * TrailingStop)) 
                  {
                     double DiffTS = OrderStopLoss() - Ask;
                     if(DiffTS > TrailingStop * Point) 
                        OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, Red); 
                  }  
               }
            }    
         }
      }
   }
   //////////////////////////////////////////////////////////////////////////////////
   double sl, tp;
   int Order_Ticket;
   //---------------------------------
   if (ObserverActivated)
   {
      if (Price2Buy != 0)
      {
         if (Ask >= (CrossPoint + PipsFilter * Point))
         {
            if (TakeProfit == 0)
               tp = 0;
            else
               tp = Ask + (TakeProfit*Point);
         
            if (StopLoss == 0)
               sl = 0;
            else
               sl = Ask - (StopLoss*Point);
               
            Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, sl, tp, "SS_EA", MagicNo, 0, Blue);
            if (Ticket < 0)
               Print("Error : ", GetLastError());
            Price2Buy = 0;
            ObserverActivated = false;
            PlaySound("alert.wav");
         }
      }
      if (Price2Sell != 0)
      {
         if (Bid <= CrossPoint - (PipsFilter * Point))
         {
            if (TakeProfit == 0)
               tp = 0;
            else
               tp = Bid - (TakeProfit * Point);
                     
            if (StopLoss == 0)
               sl = 0;
            else
               sl = Bid + (StopLoss * Point);
               
            Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, sl, tp, "SS_EA", MagicNo, 0, Gold);
            if (Ticket < 0)
               Print("Error : ", GetLastError());            
            Price2Sell = 0;
            ObserverActivated = false;
            PlaySound("alert.wav");
         }
      }
   }
//----
   double FasterMaPre = iMA(NULL, TimeFrame, FasterMAPeriod, FasterShift, FasterMethod, FasterApplyTo, 2);
   double FasterMaNow = iMA(NULL, TimeFrame, FasterMAPeriod, FasterShift, FasterMethod, FasterApplyTo, 1);
   
   double SlowerMaPre = iMA(NULL, TimeFrame, SlowerMAPeriod, SlowerShift, SlowerMethod, SlowerApplyTo, 2);
   double SlowerMaNow = iMA(NULL, TimeFrame, SlowerMAPeriod, SlowerShift, SlowerMethod, SlowerApplyTo, 1);
   
   
   //----------------------------------------------------------------------------
   datetime FY1 = Time[2];
   datetime FY2 = Time[1];
   datetime SY1 = Time[2];
   datetime SY2 = Time[1];
   //----------------------------------------------------------------------------
   
   if (Bars != DiffBar)
      OrderExecuted = false;
      
   ///////////////////////////////////////////////////////////////////////////////////////////////////
   // Without Pips Filter
   ///////////////////////////////////////////////////////////////////////////////////////////////////
   if (PipsFilter == 0)
   {
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      // BUY SIGNAL
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      if (FasterMaNow > SlowerMaNow && FasterMaPre <= SlowerMaPre)
      {
         if (SlowerMaPre == FasterMaPre)
         {
            for (int i = 2; i < Bars; i++)
            {
               double FasterB = iMA(NULL, TimeFrame, FasterMAPeriod, FasterShift, FasterMethod, FasterApplyTo, i);
               double SlowerB = iMA(NULL, TimeFrame, SlowerMAPeriod, SlowerShift, SlowerMethod, SlowerApplyTo, i);
               
               if (SlowerB < FasterB)
               {
                  if (!OrderExecuted)
                  {
                     if (TakeProfit == 0)
                        tp = 0;
                     else
                        tp = Ask + (TakeProfit*Point);
                     
                     if (StopLoss == 0)
                        sl = 0;
                     else
                        sl = Ask - (StopLoss*Point);
                     
                     Order_Ticket = GetOrderTicket();
                     if (Order_Ticket != -1)
                        OrderClose(Order_Ticket, Lots, Ask, 2, Gold);
                     
                     OrderSend(Symbol(), OP_BUY, Lots, Ask, 2, sl, tp, "AlMotawkel_EA", MagicNo, 0, Blue);
                     DiffBar = Bars;
                     OrderExecuted = true;
                     PlaySound("alert2.wav");
                     break;
                  }
               }
               else
               {
                  if (SlowerB != FasterB)
                     break;
               }
            }
         }
         else
         {
            if (!OrderExecuted)
            {
               if (TakeProfit == 0)
                  tp = 0;
               else
                  tp = Ask + (TakeProfit*Point);
                     
               if (StopLoss == 0)
                  sl = 0;
               else
                  sl = Ask - (StopLoss*Point);
               
               Order_Ticket = GetOrderTicket();
               if (Order_Ticket != -1)
                  OrderClose(Order_Ticket, Lots, Ask, 2, Gold);
                        
               OrderSend(Symbol(), OP_BUY, Lots, Ask, 2, sl, tp, "AlMotawkel_EA", MagicNo, 0, Blue);
               DiffBar = Bars;
               OrderExecuted = true;
               PlaySound("alert2.wav");
            }
         }
      }
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      // SELL SIGNAL
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      if (SlowerMaNow > FasterMaNow && SlowerMaPre <= FasterMaPre)
      {
         if (FasterMaPre == SlowerMaPre)
         {
            for (int j = 2; j < Bars; j++)
            {
               double Faster = iMA(NULL, TimeFrame, FasterMAPeriod, FasterShift, FasterMethod, FasterApplyTo, j);
               double Slower = iMA(NULL, TimeFrame, SlowerMAPeriod, SlowerShift, SlowerMethod, SlowerApplyTo, j);
               
               if (Slower > Faster)
               {
                  if (!OrderExecuted)
                  {
                     if (TakeProfit == 0)
                        tp = 0;
                     else
                        tp = Bid - (TakeProfit*Point);
                     
                     if (StopLoss == 0)
                        sl = 0;
                     else
                        sl = Bid + (StopLoss*Point);
                        
                     Order_Ticket = GetOrderTicket();
                     if (Order_Ticket != -1)
                        OrderClose(Order_Ticket, Lots, Bid, 2, Gold);
                        
                     OrderSend(Symbol(), OP_SELL, Lots, Bid, 2, sl, tp, "AlMotawkel_EA", MagicNo, 0, Red);
                     DiffBar = Bars;
                     OrderExecuted = true;
                     PlaySound("alert2.wav");
                     break;
                  }
               }
               else
               {
                  if (Slower != Faster)
                     break;
               }
            }
         }
         else
         {
            if (!OrderExecuted)
            {
               if (TakeProfit == 0)
                  tp = 0;
               else
                  tp = Bid - (TakeProfit*Point);
                     
               if (StopLoss == 0)
                  sl = 0;
               else
                  sl = Bid + (StopLoss*Point);
               
               Order_Ticket = GetOrderTicket();
               if (Order_Ticket != -1)
                  OrderClose(Order_Ticket, Lots, Bid, 2, Gold);
                        
               OrderSend(Symbol(), OP_SELL, Lots, Bid, 2, sl, tp, "AlMotawkel_EA", MagicNo, 0, Red);
               DiffBar = Bars;
               OrderExecuted = true;
               PlaySound("alert2.wav");
            }
         }
      }
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////////
   // By Using Pips Filter
   ///////////////////////////////////////////////////////////////////////////////////////////////////
   else
   {
      if (lcp == 0)
         Comment("Pips Filter Activated : " + PipsFilter);
      else
      {
         if (Price2Buy == 0 && Price2Sell == 0)
            Comment("Pips Filter Activated : " + PipsFilter + "\nLast Cross : " + DoubleToStr(lcp, Digits));
         else
         {
            if (Price2Sell == 0)
               Comment("Pips Filter Activated : " + PipsFilter + "\nLast Cross : " + DoubleToStr(lcp, Digits) + "\nWaiting 4 Executing Buy Order @ " + DoubleToStr(Price2Buy, Digits));
            else
               Comment("Pips Filter Activated : " + PipsFilter + "\nLast Cross : " + DoubleToStr(lcp, Digits) + "\nWaiting 4 Executing Sell Order @ " + DoubleToStr(Price2Sell, Digits));
         }
         
      }
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      // BUY SIGNAL
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      if (FasterMaNow > SlowerMaNow && FasterMaPre <= SlowerMaPre)
      {
         if (SlowerMaPre == FasterMaPre)
         {
            CrossPoint = SlowerMaPre;
            lcp = CrossPoint;
            for (int k = 2; k < Bars; k++)
            {
               double FasterF = iMA(NULL, 0, 30, 0, MODE_EMA, PRICE_CLOSE, k);
               double SlowerF = iMA(NULL, 0, 9, 0, MODE_EMA, PRICE_CLOSE, k);
               
               if (SlowerF < FasterF)
               {
                  if (!OrderExecuted)
                  {
                     if (TakeProfit == 0)
                        tp = 0;
                     else
                        tp = CrossPoint + (PipsFilter * Point) + (TakeProfit * Point);
                     
                     if (StopLoss == 0)
                        sl = 0;
                     else
                        sl = CrossPoint + (PipsFilter * Point) - (StopLoss * Point);
                     
                     Order_Ticket = GetOrderTicket();
                     if (Order_Ticket != -1)
                     {
                        if (Type == OP_SELL)
                           OrderClose(Order_Ticket, Lots, Ask, 2, Gold);
                        if (Type == OP_SELLSTOP)
                           OrderDelete(Order_Ticket);
                     }
                     if (ObserverActivated)
                     {
                        ObserverActivated = false;
                        Price2Sell = 0;
                     }
                           
                     Ticket = OrderSend(Symbol(), OP_BUYSTOP, Lots, CrossPoint + (PipsFilter * Point), 3, sl, tp, "SS_EA", MagicNo, 0, Blue);
                     if (Ticket < 0 && GetLastError() == 130)
                     {
                        if (Ask >= (CrossPoint + PipsFilter * Point))
                        {
                           if (TakeProfit == 0)
                              tp = 0;
                           else
                              tp = Ask + (TakeProfit * Point);
                     
                           if (StopLoss == 0)
                              sl = 0;
                           else
                              sl = Ask - (StopLoss * Point);
                           Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, sl, tp, "SS_EA", MagicNo, 0, Blue);
                           if (Ticket < 0)
                              Print("Error : ", GetLastError());
                        }
                        else
                        {
                           ObserverActivated = true;
                           Price2Buy = (CrossPoint + PipsFilter * Point);
                        }
                     }
                     DiffBar = Bars;
                     OrderExecuted = true;
                     PlaySound("alert.wav");
                  }
               }
               else
               {
                  if (SlowerF != FasterF)
                     break;
               }
            }
         }
         else
         {
            CrossPoint = GetCP(FasterMaPre, FY1, FasterMaNow, FY2, SlowerMaPre, SY1, SlowerMaNow, SY2);
            lcp = CrossPoint;
            if (!OrderExecuted)
            {
               if (TakeProfit == 0)
                  tp = 0;
               else
                  tp = CrossPoint + (PipsFilter * Point) + (TakeProfit * Point);
                     
               if (StopLoss == 0)
                  sl = 0;
               else
                  sl = CrossPoint + (PipsFilter * Point) - (StopLoss * Point);
               
               Order_Ticket = GetOrderTicket();
               if (Order_Ticket != -1)
               {
                  if (Type == OP_SELL)
                     OrderClose(Order_Ticket, Lots, Ask, 2, Gold);
                  if (Type == OP_SELLSTOP)
                     OrderDelete(Order_Ticket);
               }
               if (ObserverActivated)
               {
                  ObserverActivated = false;
                  Price2Sell = 0;
               }
                                 
               Ticket = OrderSend(Symbol(), OP_BUYSTOP, Lots, CrossPoint + (PipsFilter * Point), 3, sl, tp, "SS_EA", MagicNo, 0, Blue);
               if (Ticket < 0 && GetLastError() == 130)
               {
                  if (Ask >= (CrossPoint + PipsFilter * Point))
                  {
                     if (TakeProfit == 0)
                        tp = 0;
                     else
                        tp = Ask + (TakeProfit * Point);
                     
                     if (StopLoss == 0)
                        sl = 0;
                     else
                        sl = Ask - (StopLoss * Point);
                     Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, sl, tp, "SS_EA", MagicNo, 0, Blue);
                     if (Ticket < 0)
                        Print("Error : ", GetLastError());
                  }
                  else
                  {
                        ObserverActivated = true;
                        Price2Buy = (CrossPoint + PipsFilter * Point);
                  }
               }
               DiffBar = Bars;
               OrderExecuted = true;
               PlaySound("alert.wav");
            }
         }
      }
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      // SELL SIGNAL
      ///////////////////////////////////////////////////////////////////////////////////////////////////
      if (SlowerMaNow > FasterMaNow && SlowerMaPre <= FasterMaPre)
      {
         if (FasterMaPre == SlowerMaPre)
         {
            CrossPoint = FasterMaPre;
            lcp = CrossPoint;
            for (int l = 2; l < Bars; l++)
            {
               double FasterS = iMA(NULL, TimeFrame, FasterMAPeriod, FasterShift, FasterMethod, FasterApplyTo, l);
               double SlowerS = iMA(NULL, TimeFrame, SlowerMAPeriod, SlowerShift, SlowerMethod, SlowerApplyTo, l);
               
               if (SlowerS > FasterS)
               {
                  if (!OrderExecuted)
                  {
                     if (TakeProfit == 0)
                        tp = 0;
                     else
                        tp = CrossPoint - (PipsFilter * Point) - (TakeProfit * Point);
                     
                     if (StopLoss == 0)
                        sl = 0;
                     else
                        sl = CrossPoint - (PipsFilter * Point) + (StopLoss * Point);
                     
                     Order_Ticket = GetOrderTicket();
                     if (Order_Ticket != -1)
                     {
                        if (Type == OP_BUY)
                           OrderClose(Order_Ticket, Lots, Bid, 2, Gold);
                        if (Type == OP_BUYSTOP)
                           OrderDelete(Order_Ticket);
                     }
                     if (ObserverActivated)
                     {
                        ObserverActivated = false;
                        Price2Buy = 0;
                     }
                        
                     Ticket = OrderSend(Symbol(), OP_SELLSTOP, Lots, CrossPoint - (PipsFilter * Point), 3, sl, tp, "SS_EA", MagicNo, 0, Gold);
                     if (Ticket < 0 && GetLastError() == 130)
                     {
                        if (Bid <= CrossPoint - (PipsFilter * Point))
                        {
                           if (TakeProfit == 0)
                              tp = 0;
                           else
                              tp = Bid - (TakeProfit * Point);
                     
                           if (StopLoss == 0)
                              sl = 0;
                           else
                              sl = Bid + (StopLoss * Point);
                           Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, sl, tp, "SS_EA", MagicNo, 0, Gold);
                           if (Ticket < 0)
                              Print("Error : ", GetLastError());
                        }
                        else
                        {
                           ObserverActivated = true;
                           Price2Sell = CrossPoint - (PipsFilter * Point);
                        }
                     }
                     DiffBar = Bars;
                     OrderExecuted = true;
                     PlaySound("alert.wav");
                  }
               }
               else
               {
                  if (SlowerS != FasterS)
                     break;
               }
            }
         }
         else
         {
            CrossPoint = GetCP(FasterMaPre, FY1, FasterMaNow, FY2, SlowerMaPre, SY1, SlowerMaNow, SY2);
            lcp = CrossPoint;
            if (!OrderExecuted)
            {
               if (TakeProfit == 0)
                  tp = 0;
               else
                  tp = CrossPoint - (PipsFilter * Point) - (TakeProfit * Point);
                     
               if (StopLoss == 0)
                  sl = 0;
               else
                  sl = CrossPoint - (PipsFilter * Point) + (StopLoss * Point);
               
               Order_Ticket = GetOrderTicket();
               if (Order_Ticket != -1)
               {
                  if (Type == OP_BUY)
                     OrderClose(Order_Ticket, Lots, Bid, 2, Gold);
                  if (Type == OP_BUYSTOP)
                     OrderDelete(Order_Ticket);
               }
               if (ObserverActivated)
               {
                  ObserverActivated = false;
                  Price2Buy = 0;
               }
                         
               Ticket = OrderSend(Symbol(), OP_SELLSTOP, Lots, CrossPoint - (PipsFilter * Point), 3, sl, tp, "SS_EA", MagicNo, 0, Gold);
               if (Ticket < 0 && GetLastError() == 130)
               {
                  if (Bid <= CrossPoint - (PipsFilter * Point))
                  {
                     if (TakeProfit == 0)
                        tp = 0;
                     else
                        tp = Bid - (TakeProfit * Point);
                     
                     if (StopLoss == 0)
                        sl = 0;
                     else
                        sl = Bid + (StopLoss * Point);
                     Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, sl, tp, "SS_EA", MagicNo, 0, Gold);
                     if (Ticket < 0)
                        Print("Error : ", GetLastError());
                  }
                  else
                  {
                        ObserverActivated = true;
                        Price2Sell = CrossPoint - (PipsFilter * Point);
                  }
               }
               DiffBar = Bars;
               OrderExecuted = true;
               PlaySound("alert.wav");
            }
         }
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int GetOrderTicket()
{
   int ticket = -1;
   for (int i = 0; i < OrdersTotal(); i++)
   {
      if( OrderSelect(i, SELECT_BY_POS, MODE_TRADES) )
      {
         if ( Symbol() == OrderSymbol() && MagicNo == OrderMagicNumber() )
         {
            ticket = OrderTicket();
            Type = OrderType();
         }
      }
   }
   return (ticket);
}
//+------------------------------------------------------------------+
double GetCP(double FastX1, datetime FastY1, double FastX2, datetime FastY2, double SlowX1, datetime SlowY1, double SlowX2, datetime SlowY2)
{
   double FastX = 1, SlowY = 1, SlowX = 1;
   if ((FastX2 - FastX1) == 0)
      return (FastX2);
   if ((SlowX2 - SlowX1) == 0)
      return (SlowX2);
   double FastSlope = (FastY2 - FastY1) / (FastX2 - FastX1);
   double SlowSlope = (SlowY2 - SlowY1) / (SlowX2 - SlowX1);
   
   double CP = ((SlowY1 + (SlowSlope * SlowX1)) - (FastY1 + (FastSlope * FastX1))) / ((SlowSlope * SlowX) - (FastSlope * FastX));
   return (NormalizeDouble(CP, Digits));
}